﻿using System;
using System.Collections.Generic;
using InternshipSystem.Core.Commands;
using InternshipSystem.Core.Entity.Internship;
using InternshipSystem.Core.UglyOrmArtifacts;

namespace InternshipSystem.Core
{
    public class InternshipRegistration
    {
        public long Id { get; set; }
        public Company Company { get; set; }
        public BranchOffice BranchAddress { get; set; }
        public DateTime Start { get; set; }
        public DateTime End { get; set; }
        public Mentor Mentor { get; set; }
        
        public List<ProgramSubject> ChosenSubjects { get; set; }
        public InternshipType Type { get; set; }
        public DocumentState State { get; set; }
        
        public static InternshipRegistration Create()
        {
            return new InternshipRegistration();
        }

        public void Update(DateTime start, DateTime end, InternshipType internshipType)
        {
            Start = start;
            End = end;
            Type = internshipType;
        }

        public void UpdateCompany(UpdateCompany? updateRegistrationCompany)
        {
            throw new NotImplementedException();
        }

        public void UpdateDates(DateTime? updateRegistrationStart, DateTime? updateRegistrationEnd)
        {
            throw new NotImplementedException();
        }

        public void UpdateMentor(UpdateMentor updateRegistrationMentor)
        {
            throw new NotImplementedException();
        }

        public void UpdateSubjects(List<InternshipSubject> updateRegistrationSubjects)
        {
            throw new NotImplementedException();
        }

        public void UpdateInternshipType(InternshipType updateRegistrationType)
        {
            throw new NotImplementedException();
        }
    }
}